'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setFilter = exports.toggle = exports.update = exports.reset = undefined;

var _constants = require('@instructure/quiz-common/lib/constants');

var reset = exports.reset = function reset() {
  return {
    type: _constants.SEARCH_RESET
  };
};

var update = exports.update = function update(text) {
  return {
    payload: { text: text },
    type: _constants.SEARCH_UPDATE
  };
};

var toggle = exports.toggle = function toggle(filter, key) {
  return {
    payload: { filter: filter, key: key },
    type: _constants.SEARCH_TOGGLE
  };
};

var setFilter = exports.setFilter = function setFilter(filter, value) {
  return {
    payload: { filter: filter, value: value },
    type: _constants.SEARCH_SET
  };
};